Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs	(revision 12720)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs	(revision 12721)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,17 +32,20 @@
 
 namespace HeuristicLab.Problems.Orienteering {
-  [Item("OrienteeringShakingOperator", @"The used neighborhood operator is based on a two point exchange move. A move in
-the k-th neighborhood consists of removing k consecutive vertices from the tour, starting
-at a randomly selected position. Afterwards, a sorted list of all vertices not yet included
-in the current tour is built. The vertices are sorted in descending order with respect to the
-objective value increase using the current weights. Out of the first three entries with the
-highest ranking in this list, one randomly selected vertex is reinserted into the current tour
-at the same position as the removed vertices. This way, l new vertices are inserted into the
-tour. The largest neighborhood is a complete exchange of all vertices on the tour. 
-The shaking procedure does not guarantee that the new tour does not exceed the cost
-limit Tmax. Therefore, in a repair step, a sorted list of all vertices in the tour is created. The
-vertices are sorted in descending order with respect to costs saved when removing the vertex
-from the tour. Vertices are removed as long as the cost limit is violated.
-(Schilde et. al. 2009)")]
+  /// <summary>
+  /// The used neighborhood operator is based on a two point exchange move. A move in
+  /// the k-th neighborhood consists of removing k consecutive vertices from the tour, starting
+  /// at a randomly selected position. Afterwards, a sorted list of all vertices not yet included
+  /// in the current tour is built. The vertices are sorted in descending order with respect to the
+  /// objective value increase using the current weights. Out of the first three entries with the
+  /// highest ranking in this list, one randomly selected vertex is reinserted into the current tour
+  /// at the same position as the removed vertices. This way, l new vertices are inserted into the
+  /// tour. The largest neighborhood is a complete exchange of all vertices on the tour. 
+  /// The shaking procedure does not guarantee that the new tour does not exceed the cost
+  /// limit Tmax. Therefore, in a repair step, a sorted list of all vertices in the tour is created. The
+  /// vertices are sorted in descending order with respect to costs saved when removing the vertex
+  /// from the tour. Vertices are removed as long as the cost limit is violated.
+  /// (Schilde et. al. 2009)
+  /// </summary>
+  [Item("OrienteeringShakingOperator", @"Implements the shaking procedure described in Schilde M., Doerner K.F., Hartl R.F., Kiechle G. 2009. Metaheuristics for the bi-objective orienteering problem. Swarm Intelligence, Volume 3, Issue 3, pp 179-201.")]
   [StorableClass]
   public sealed class OrienteeringShakingOperator : SingleSuccessorOperator, IMultiNeighborhoodShakingOperator, IStochasticOperator {
@@ -131,5 +134,5 @@
         int maximumNeighborhood = initialTour.Length - 2; // neighborhood limit within [0, changable tour length - 1)
         maximumNeighborhood = (maximumNeighborhood > currentNeighborhood) ? currentNeighborhood : maximumNeighborhood;
-        int neighborhood = maximumNeighborhood;//random.Next(maximumNeighborhood) + 1;
+        int neighborhood = maximumNeighborhood;
 
         // Find all points that are not yet included in the tour and are
@@ -165,4 +168,5 @@
       return base.Apply();
     }
+
     private void InsertPoints(List<int> actualTour, IntegerVector initialTour,
       int neighborhood, List<int> visitablePoints, IRandom random) {
@@ -208,4 +212,5 @@
       }
     }
+
     private void CleanupTour(List<int> actualTour, DistanceMatrix distances, double maxDistance, double pointVisitingCosts) {
       // Sort the points on the tour according to their costs savings when removed
@@ -235,5 +240,5 @@
       }
     }
-    // 
+
     private class SavingInfo {
       public int Index;
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Tests/HeuristicLab-3.3/Samples/VnsOpSampleTest.cs
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Tests/HeuristicLab-3.3/Samples/VnsOpSampleTest.cs	(revision 12721)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Tests/HeuristicLab-3.3/Samples/VnsOpSampleTest.cs	(revision 12721)
@@ -0,0 +1,95 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.IO;
+using System.Linq;
+using HeuristicLab.Algorithms.VariableNeighborhoodSearch;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.Problems.Orienteering;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests {
+  [TestClass]
+  public class VnsOpSampleTest {
+    private const string SampleFileName = "VNS_OP";
+
+    [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
+    public void CreateVnsTspSampleTest() {
+      var vns = CreateVnsTspSample();
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(vns, path);
+    }
+    [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
+    public void RunVnsTspSampleTest() {
+      var vns = CreateVnsTspSample();
+      vns.SetSeedRandomly = false;
+      SamplesUtils.RunAlgorithm(vns);
+      Assert.AreEqual(1182, SamplesUtils.GetDoubleResult(vns, "BestQuality"));
+      Assert.AreEqual(1182, SamplesUtils.GetDoubleResult(vns, "CurrentAverageQuality"));
+      Assert.AreEqual(1182, SamplesUtils.GetDoubleResult(vns, "CurrentWorstQuality"));
+      Assert.AreEqual(42651753, SamplesUtils.GetIntResult(vns, "EvaluatedSolutions"));
+    }
+
+    private VariableNeighborhoodSearch CreateVnsTspSample() {
+      VariableNeighborhoodSearch vns = new VariableNeighborhoodSearch();
+      #region Problem Configuration
+      OrienteeringProblem opProblem = new OrienteeringProblem();
+      opProblem.BestKnownQuality = new DoubleValue(1188);
+      opProblem.BestKnownSolution = new IntegerVector(new[] {
+0, 1, 3, 6, 11, 17, 24, 18, 13, 19, 14, 20, 26, 34, 27, 35, 42, 48, 53, 57, 52, 47, 41, 33, 25, 32, 40, 46, 39, 31, 38, 50, 44, 37, 30, 23, 16, 10, 15, 22, 29, 21, 28, 36, 43, 49, 54, 58, 61, 63 
+      });
+      opProblem.Coordinates = new DoubleMatrix(new double[,] {
+{ 7, 0 },{ 6, 1 },{ 8, 1 },{ 5, 2 },{ 7, 2 },{ 9, 2 },{ 4, 3 },{ 6, 3 },{ 8, 3 },{ 10, 3 },{ 3, 4 },{ 5, 4 },{ 7, 4 },{ 9, 4 },{ 11, 4 },{ 2, 5 },{ 4, 5 },{ 6, 5 },{ 8, 5 },{ 10, 5 },{ 12, 5 },{ 1, 6 },{ 3, 6 },{ 5, 6 },{ 7, 6 },{ 9, 6 },{ 11, 6 },{ 13, 6 },{ 0, 7 },{ 2, 7 },{ 4, 7 },{ 6, 7 },{ 8, 7 },{ 10, 7 },{ 12, 7 },{ 14, 7 },{ 1, 8 },{ 3, 8 },{ 5, 8 },{ 7, 8 },{ 9, 8 },{ 11, 8 },{ 13, 8 },{ 2, 9 },{ 4, 9 },{ 6, 9 },{ 8, 9 },{ 10, 9 },{ 12, 9 },{ 3, 10 },{ 5, 10 },{ 7, 10 },{ 9, 10 },{ 11, 10 },{ 4, 11 },{ 6, 11 },{ 8, 11 },{ 10, 11 },{ 5, 12 },{ 7, 12 },{ 9, 12 },{ 6, 13 },{ 8, 13 },{ 7, 14 }
+      });
+      opProblem.MaximumDistance = 70;
+      opProblem.PointVisitingCosts = 0;
+      opProblem.Scores = new DoubleArray(new double[] {
+0, 6, 6, 12, 6, 12, 18, 12, 12, 18, 24, 18, 12, 18, 24, 30, 24, 18, 18, 24, 30, 36, 30, 24, 18, 24, 30, 36, 42, 36, 30, 24, 24, 30, 36, 42, 36, 30, 24, 18, 24, 30, 36, 30, 24, 18, 18, 24, 30, 24, 18, 12, 18, 24, 18, 12, 12, 18, 12, 6, 12, 6, 6, 0
+      });
+      opProblem.StartingPoint = 0;
+      opProblem.TerminalPoint = 63;
+
+      opProblem.Name = "1_p64_t070";
+      opProblem.Description = "Represents a symmetric Traveling Salesman Problem.";
+      #endregion
+      #region Algorithm Configuration
+      vns.Name = "Variable Neighborhood Search - TSP";
+      vns.Description = "A variable neighborhood search algorithm which solves a funny TSP instance";
+      vns.Problem = opProblem;
+
+      vns.LocalImprovement = vns.LocalImprovementParameter.ValidValues.OfType<OrienteeringLocalImprovementOperator>().Single();
+      vns.LocalImprovementMaximumIterations = 200;
+      vns.MaximumIterations = 25;
+      vns.Seed = 0;
+      vns.SetSeedRandomly = true;
+      vns.ShakingOperator = vns.ShakingOperatorParameter.ValidValues.OfType<OrienteeringShakingOperator>().Single();
+      #endregion
+      vns.Engine = new ParallelEngine.ParallelEngine();
+      return vns;
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 12720)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 12721)
@@ -422,4 +422,5 @@
     <Compile Include="HeuristicLab-3.3\PluginDependenciesTest.cs" />
     <Compile Include="HeuristicLab-3.3\PluginLoader.cs" />
+    <Compile Include="HeuristicLab-3.3\Samples\VnsOpSampleTest.cs" />
     <Compile Include="HeuristicLab-3.3\Samples\EsGriewankSampleTest.cs" />
     <Compile Include="HeuristicLab-3.3\Samples\GaussianProcessRegressionSampleTest.cs" />
